# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GitFusionRepoBranchConfig(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GitFusionRepoBranchConfig - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'git_branch_id': 'str',
            'git_branch_name': 'str',
            'view': 'list[str]',
            'stream': 'str',
            'read_only': 'str'
        }

        self.attribute_map = {
            'git_branch_id': 'gitBranchId',
            'git_branch_name': 'gitBranchName',
            'view': 'view',
            'stream': 'stream',
            'read_only': 'readOnly'
        }

        self._git_branch_id = None
        self._git_branch_name = None
        self._view = None
        self._stream = None
        self._read_only = None

    @property
    def git_branch_id(self):
        """
        Gets the git_branch_id of this GitFusionRepoBranchConfig.
        Alphanumeric ID for the git branch.\n_Do not change this value once this repo has been cloned_.

        :return: The git_branch_id of this GitFusionRepoBranchConfig.
        :rtype: str
        """
        return self._git_branch_id

    @git_branch_id.setter
    def git_branch_id(self, git_branch_id):
        """
        Sets the git_branch_id of this GitFusionRepoBranchConfig.
        Alphanumeric ID for the git branch.\n_Do not change this value once this repo has been cloned_.

        :param git_branch_id: The git_branch_id of this GitFusionRepoBranchConfig.
        :type: str
        """
        self._git_branch_id = git_branch_id

    @property
    def git_branch_name(self):
        """
        Gets the git_branch_name of this GitFusionRepoBranchConfig.
        Defines a name specified in a local repo for a Git branch.\n\nA valid Git branch name.\nDo not edit this value after you clone the repo.

        :return: The git_branch_name of this GitFusionRepoBranchConfig.
        :rtype: str
        """
        return self._git_branch_name

    @git_branch_name.setter
    def git_branch_name(self, git_branch_name):
        """
        Sets the git_branch_name of this GitFusionRepoBranchConfig.
        Defines a name specified in a local repo for a Git branch.\n\nA valid Git branch name.\nDo not edit this value after you clone the repo.

        :param git_branch_name: The git_branch_name of this GitFusionRepoBranchConfig.
        :type: str
        """
        self._git_branch_name = git_branch_name

    @property
    def view(self):
        """
        Gets the view of this GitFusionRepoBranchConfig.
        Defines a Perforce workspace view mapping that maps Perforce depot paths (left side) to Git work tree paths (right side).\n\nCorrectly formed mapping syntax; must not include any Perforce stream or spec depots, and all depot paths on the right side must match exactly across all branch definitions.\nYou can add and remove only certain types of Perforce branches from this view after you clone the repo.

        :return: The view of this GitFusionRepoBranchConfig.
        :rtype: list[str]
        """
        return self._view

    @view.setter
    def view(self, view):
        """
        Sets the view of this GitFusionRepoBranchConfig.
        Defines a Perforce workspace view mapping that maps Perforce depot paths (left side) to Git work tree paths (right side).\n\nCorrectly formed mapping syntax; must not include any Perforce stream or spec depots, and all depot paths on the right side must match exactly across all branch definitions.\nYou can add and remove only certain types of Perforce branches from this view after you clone the repo.

        :param view: The view of this GitFusionRepoBranchConfig.
        :type: list[str]
        """
        self._view = view

    @property
    def stream(self):
        """
        Gets the stream of this GitFusionRepoBranchConfig.
        Defines a Perforce stream that maps to the Git branch.\n\nProvide a stream name using the syntax //streamdepot/mystream.\nA Git Fusion branch can be defined as a view or a stream but not both.\nIf your branch is defined as stream, it can include only one stream.

        :return: The stream of this GitFusionRepoBranchConfig.
        :rtype: str
        """
        return self._stream

    @stream.setter
    def stream(self, stream):
        """
        Sets the stream of this GitFusionRepoBranchConfig.
        Defines a Perforce stream that maps to the Git branch.\n\nProvide a stream name using the syntax //streamdepot/mystream.\nA Git Fusion branch can be defined as a view or a stream but not both.\nIf your branch is defined as stream, it can include only one stream.

        :param stream: The stream of this GitFusionRepoBranchConfig.
        :type: str
        """
        self._stream = stream

    @property
    def read_only(self):
        """
        Gets the read_only of this GitFusionRepoBranchConfig.
        Prohibit git pushes that introduce commits to the branch.

        :return: The read_only of this GitFusionRepoBranchConfig.
        :rtype: str
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """
        Sets the read_only of this GitFusionRepoBranchConfig.
        Prohibit git pushes that introduce commits to the branch.

        :param read_only: The read_only of this GitFusionRepoBranchConfig.
        :type: str
        """
        self._read_only = read_only

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

